local e=require("simple-uci").cursor()
local n=require'gluon.wireless'
local t=require'gluon.util'
local i='wan_radio0'
local d=Form(translate("Private WLAN"))
local o=d:section(Section,nil,translate(
'Your node can additionally extend your private network by bridging the WAN interface '
..'with a separate WLAN. This feature is completely independent of the mesh functionality. '
..'Please note that the private WLAN and meshing on the WAN interface should not be enabled '
..'at the same time.'
))
local s=t.get_role_interfaces(e,'uplink')
local a=false
for o,e in ipairs(t.get_role_interfaces(e,'mesh'))do
if t.contains(s,e)then
a=true
end
end
local t=o:option(Flag,"enabled",translate("Enabled"))
t.default=e:get('wireless',i)and not e:get_bool('wireless',i,"disabled")
local a=o:element('model/warning',{
content=translate(
'Meshing on WAN interface is enabled. '..
'This can lead to problems.'
),
hide=not a,
},'warning')
a:depends(t,true)
local s=o:option(Value,"ssid",translate("Name (SSID)"))
s:depends(t,true)
s.datatype="maxlength(32)"
s.default=e:get('wireless',i,"ssid")
local h=o:option(Value,"key",translate("Key"),translate("8-63 characters"))
h:depends(t,true)
h.datatype="wpakey"
h.default=e:get('wireless',i,"key")
local a=o:option(ListValue,"encryption",translate("Encryption"))
a:depends(t,true)
a:value("psk2",translate("WPA2"))
if n.device_supports_wpa3()then
a:value("psk3-mixed",translate("WPA2 / WPA3"))
a:value("psk3",translate("WPA3"))
end
a.default=e:get('wireless',i,'encryption')or"psk2"
local o=o:option(ListValue,"mfp",translate("Management Frame Protection"))
o:depends(t,true)
o:value("0",translate("Disabled"))
if n.device_supports_mfp(e)then
o:value("1",translate("Optional"))
o:value("2",translate("Required"))
end
o.default=e:get('wireless',i,'ieee80211w')or"0"
function d:write()
n.foreach_radio(e,function(l,u)
local r=l['.name']
local d=r:match('^radio(%d+)$')
local i="wan_"..r
if t.data then
local t=n.get_wlan_mac(e,l,u,4)
e:section('wireless','wifi-iface',i,{
device=r,
network='wan',
mode='ap',
encryption=a.data,
ssid=s.data,
key=h.data,
macaddr=t,
ifname=d and'wl-wan'..d,
disabled=false,
})
if n.device_supports_mfp(e)then
e:set('wireless',i,'ieee80211w',o.data)
else
e:delete('wireless',i,'ieee80211w')
end
else
e:set('wireless',i,"disabled",true)
end
end)
e:commit('wireless')
end
return d
